-- description: stuff i thought was useful for testing with king
-- name: King's Devtools

ACT_KTOOLS_DEBUG_MOVE = allocate_mario_action(ACT_GROUP_CUTSCENE | ACT_FLAG_STATIONARY | ACT_FLAG_INTANGIBLE)
ACT_KTOOLS_LOCKED = allocate_mario_action(ACT_GROUP_CUTSCENE | ACT_FLAG_STATIONARY | ACT_FLAG_INTANGIBLE)

local actNames = {
    [ACT_UNINITIALIZED] = "ACT_UNINITIALIZED",
    [ACT_IDLE] = "ACT_IDLE",
    [ACT_START_SLEEPING] = "ACT_START_SLEEPING",
    [ACT_SLEEPING] = "ACT_SLEEPING",
    [ACT_WAKING_UP] = "ACT_WAKING_UP",
    [ACT_PANTING] = "ACT_PANTING",
    [ACT_HOLD_PANTING_UNUSED] = "ACT_HOLD_PANTING_UNUSED",
    [ACT_HOLD_IDLE] = "ACT_HOLD_IDLE",
    [ACT_HOLD_HEAVY_IDLE] = "ACT_HOLD_HEAVY_IDLE",
    [ACT_STANDING_AGAINST_WALL] = "ACT_STANDING_AGAINST_WALL",
    [ACT_COUGHING] = "ACT_COUGHING",
    [ACT_SHIVERING] = "ACT_SHIVERING",
    [ACT_IN_QUICKSAND] = "ACT_IN_QUICKSAND",
    [ACT_UNKNOWN_0002020E] = "ACT_UNKNOWN_0002020E",
    [ACT_CROUCHING] = "ACT_CROUCHING",
    [ACT_START_CROUCHING] = "ACT_START_CROUCHING",
    [ACT_STOP_CROUCHING] = "ACT_STOP_CROUCHING",
    [ACT_START_CRAWLING] = "ACT_START_CRAWLING",
    [ACT_STOP_CRAWLING] = "ACT_STOP_CRAWLING",
    [ACT_SLIDE_KICK_SLIDE_STOP] = "ACT_SLIDE_KICK_SLIDE_STOP",
    [ACT_SHOCKWAVE_BOUNCE] = "ACT_SHOCKWAVE_BOUNCE",
    [ACT_FIRST_PERSON] = "ACT_FIRST_PERSON",
    [ACT_BACKFLIP_LAND_STOP] = "ACT_BACKFLIP_LAND_STOP",
    [ACT_JUMP_LAND_STOP] = "ACT_JUMP_LAND_STOP",
    [ACT_DOUBLE_JUMP_LAND_STOP] = "ACT_DOUBLE_JUMP_LAND_STOP",
    [ACT_FREEFALL_LAND_STOP] = "ACT_FREEFALL_LAND_STOP",
    [ACT_SIDE_FLIP_LAND_STOP] = "ACT_SIDE_FLIP_LAND_STOP",
    [ACT_HOLD_JUMP_LAND_STOP] = "ACT_HOLD_JUMP_LAND_STOP",
    [ACT_HOLD_FREEFALL_LAND_STOP] = "ACT_HOLD_FREEFALL_LAND_STOP",
    [ACT_AIR_THROW_LAND] = "ACT_AIR_THROW_LAND",
    [ACT_TWIRL_LAND] = "ACT_TWIRL_LAND",
    [ACT_LAVA_BOOST_LAND] = "ACT_LAVA_BOOST_LAND",
    [ACT_TRIPLE_JUMP_LAND_STOP] = "ACT_TRIPLE_JUMP_LAND_STOP",
    [ACT_LONG_JUMP_LAND_STOP] = "ACT_LONG_JUMP_LAND_STOP",
    [ACT_GROUND_POUND_LAND] = "ACT_GROUND_POUND_LAND",
    [ACT_BRAKING_STOP] = "ACT_BRAKING_STOP",
    [ACT_BUTT_SLIDE_STOP] = "ACT_BUTT_SLIDE_STOP",
    [ACT_HOLD_BUTT_SLIDE_STOP] = "ACT_HOLD_BUTT_SLIDE_STOP",
    [ACT_WALKING] = "ACT_WALKING",
    [ACT_HOLD_WALKING] = "ACT_HOLD_WALKING",
    [ACT_TURNING_AROUND] = "ACT_TURNING_AROUND",
    [ACT_FINISH_TURNING_AROUND] = "ACT_FINISH_TURNING_AROUND",
    [ACT_BRAKING] = "ACT_BRAKING",
    [ACT_RIDING_SHELL_GROUND] = "ACT_RIDING_SHELL_GROUND",
    [ACT_HOLD_HEAVY_WALKING] = "ACT_HOLD_HEAVY_WALKING",
    [ACT_CRAWLING] = "ACT_CRAWLING",
    [ACT_BURNING_GROUND] = "ACT_BURNING_GROUND",
    [ACT_DECELERATING] = "ACT_DECELERATING",
    [ACT_HOLD_DECELERATING] = "ACT_HOLD_DECELERATING",
    [ACT_BEGIN_SLIDING] = "ACT_BEGIN_SLIDING",
    [ACT_HOLD_BEGIN_SLIDING] = "ACT_HOLD_BEGIN_SLIDING",
    [ACT_BUTT_SLIDE] = "ACT_BUTT_SLIDE",
    [ACT_STOMACH_SLIDE] = "ACT_STOMACH_SLIDE",
    [ACT_HOLD_BUTT_SLIDE] = "ACT_HOLD_BUTT_SLIDE",
    [ACT_HOLD_STOMACH_SLIDE] = "ACT_HOLD_STOMACH_SLIDE",
    [ACT_DIVE_SLIDE] = "ACT_DIVE_SLIDE",
    [ACT_MOVE_PUNCHING] = "ACT_MOVE_PUNCHING",
    [ACT_CROUCH_SLIDE] = "ACT_CROUCH_SLIDE",
    [ACT_SLIDE_KICK_SLIDE] = "ACT_SLIDE_KICK_SLIDE",
    [ACT_HARD_BACKWARD_GROUND_KB] = "ACT_HARD_BACKWARD_GROUND_KB",
    [ACT_HARD_FORWARD_GROUND_KB] = "ACT_HARD_FORWARD_GROUND_KB",
    [ACT_BACKWARD_GROUND_KB] = "ACT_BACKWARD_GROUND_KB",
    [ACT_FORWARD_GROUND_KB] = "ACT_FORWARD_GROUND_KB",
    [ACT_SOFT_BACKWARD_GROUND_KB] = "ACT_SOFT_BACKWARD_GROUND_KB",
    [ACT_SOFT_FORWARD_GROUND_KB] = "ACT_SOFT_FORWARD_GROUND_KB",
    [ACT_GROUND_BONK] = "ACT_GROUND_BONK",
    [ACT_DEATH_EXIT_LAND] = "ACT_DEATH_EXIT_LAND",
    [ACT_JUMP_LAND] = "ACT_JUMP_LAND",
    [ACT_FREEFALL_LAND] = "ACT_FREEFALL_LAND",
    [ACT_DOUBLE_JUMP_LAND] = "ACT_DOUBLE_JUMP_LAND",
    [ACT_SIDE_FLIP_LAND] = "ACT_SIDE_FLIP_LAND",
    [ACT_HOLD_JUMP_LAND] = "ACT_HOLD_JUMP_LAND",
    [ACT_HOLD_FREEFALL_LAND] = "ACT_HOLD_FREEFALL_LAND",
    [ACT_QUICKSAND_JUMP_LAND] = "ACT_QUICKSAND_JUMP_LAND",
    [ACT_HOLD_QUICKSAND_JUMP_LAND] = "ACT_HOLD_QUICKSAND_JUMP_LAND",
    [ACT_TRIPLE_JUMP_LAND] = "ACT_TRIPLE_JUMP_LAND",
    [ACT_LONG_JUMP_LAND] = "ACT_LONG_JUMP_LAND",
    [ACT_BACKFLIP_LAND] = "ACT_BACKFLIP_LAND",
    [ACT_JUMP] = "ACT_JUMP",
    [ACT_DOUBLE_JUMP] = "ACT_DOUBLE_JUMP",
    [ACT_TRIPLE_JUMP] = "ACT_TRIPLE_JUMP",
    [ACT_BACKFLIP] = "ACT_BACKFLIP",
    [ACT_STEEP_JUMP] = "ACT_STEEP_JUMP",
    [ACT_WALL_KICK_AIR] = "ACT_WALL_KICK_AIR",
    [ACT_SIDE_FLIP] = "ACT_SIDE_FLIP",
    [ACT_LONG_JUMP] = "ACT_LONG_JUMP",
    [ACT_WATER_JUMP] = "ACT_WATER_JUMP",
    [ACT_DIVE] = "ACT_DIVE",
    [ACT_FREEFALL] = "ACT_FREEFALL",
    [ACT_TOP_OF_POLE_JUMP] = "ACT_TOP_OF_POLE_JUMP",
    [ACT_BUTT_SLIDE_AIR] = "ACT_BUTT_SLIDE_AIR",
    [ACT_FLYING_TRIPLE_JUMP] = "ACT_FLYING_TRIPLE_JUMP",
    [ACT_SHOT_FROM_CANNON] = "ACT_SHOT_FROM_CANNON",
    [ACT_FLYING] = "ACT_FLYING",
    [ACT_RIDING_SHELL_JUMP] = "ACT_RIDING_SHELL_JUMP",
    [ACT_RIDING_SHELL_FALL] = "ACT_RIDING_SHELL_FALL",
    [ACT_VERTICAL_WIND] = "ACT_VERTICAL_WIND",
    [ACT_HOLD_JUMP] = "ACT_HOLD_JUMP",
    [ACT_HOLD_FREEFALL] = "ACT_HOLD_FREEFALL",
    [ACT_HOLD_BUTT_SLIDE_AIR] = "ACT_HOLD_BUTT_SLIDE_AIR",
    [ACT_HOLD_WATER_JUMP] = "ACT_HOLD_WATER_JUMP",
    [ACT_TWIRLING] = "ACT_TWIRLING",
    [ACT_FORWARD_ROLLOUT] = "ACT_FORWARD_ROLLOUT",
    [ACT_AIR_HIT_WALL] = "ACT_AIR_HIT_WALL",
    [ACT_RIDING_HOOT] = "ACT_RIDING_HOOT",
    [ACT_GROUND_POUND] = "ACT_GROUND_POUND",
    [ACT_SLIDE_KICK] = "ACT_SLIDE_KICK",
    [ACT_AIR_THROW] = "ACT_AIR_THROW",
    [ACT_JUMP_KICK] = "ACT_JUMP_KICK",
    [ACT_BACKWARD_ROLLOUT] = "ACT_BACKWARD_ROLLOUT",
    [ACT_CRAZY_BOX_BOUNCE] = "ACT_CRAZY_BOX_BOUNCE",
    [ACT_SPECIAL_TRIPLE_JUMP] = "ACT_SPECIAL_TRIPLE_JUMP",
    [ACT_BACKWARD_AIR_KB] = "ACT_BACKWARD_AIR_KB",
    [ACT_FORWARD_AIR_KB] = "ACT_FORWARD_AIR_KB",
    [ACT_HARD_FORWARD_AIR_KB] = "ACT_HARD_FORWARD_AIR_KB",
    [ACT_HARD_BACKWARD_AIR_KB] = "ACT_HARD_BACKWARD_AIR_KB",
    [ACT_BURNING_JUMP] = "ACT_BURNING_JUMP",
    [ACT_BURNING_FALL] = "ACT_BURNING_FALL",
    [ACT_SOFT_BONK] = "ACT_SOFT_BONK",
    [ACT_LAVA_BOOST] = "ACT_LAVA_BOOST",
    [ACT_GETTING_BLOWN] = "ACT_GETTING_BLOWN",
    [ACT_THROWN_FORWARD] = "ACT_THROWN_FORWARD",
    [ACT_THROWN_BACKWARD] = "ACT_THROWN_BACKWARD",
    [ACT_WATER_IDLE] = "ACT_WATER_IDLE",
    [ACT_HOLD_WATER_IDLE] = "ACT_HOLD_WATER_IDLE",
    [ACT_WATER_ACTION_END] = "ACT_WATER_ACTION_END",
    [ACT_HOLD_WATER_ACTION_END] = "ACT_HOLD_WATER_ACTION_END",
    [ACT_DROWNING] = "ACT_DROWNING",
    [ACT_BACKWARD_WATER_KB] = "ACT_BACKWARD_WATER_KB",
    [ACT_FORWARD_WATER_KB] = "ACT_FORWARD_WATER_KB",
    [ACT_WATER_DEATH] = "ACT_WATER_DEATH",
    [ACT_WATER_SHOCKED] = "ACT_WATER_SHOCKED",
    [ACT_BREASTSTROKE] = "ACT_BREASTSTROKE",
    [ACT_SWIMMING_END] = "ACT_SWIMMING_END",
    [ACT_FLUTTER_KICK] = "ACT_FLUTTER_KICK",
    [ACT_HOLD_BREASTSTROKE] = "ACT_HOLD_BREASTSTROKE",
    [ACT_HOLD_SWIMMING_END] = "ACT_HOLD_SWIMMING_END",
    [ACT_HOLD_FLUTTER_KICK] = "ACT_HOLD_FLUTTER_KICK",
    [ACT_WATER_SHELL_SWIMMING] = "ACT_WATER_SHELL_SWIMMING",
    [ACT_WATER_THROW] = "ACT_WATER_THROW",
    [ACT_WATER_PUNCH] = "ACT_WATER_PUNCH",
    [ACT_WATER_PLUNGE] = "ACT_WATER_PLUNGE",
    [ACT_CAUGHT_IN_WHIRLPOOL] = "ACT_CAUGHT_IN_WHIRLPOOL",
    [ACT_METAL_WATER_STANDING] = "ACT_METAL_WATER_STANDING",
    [ACT_HOLD_METAL_WATER_STANDING] = "ACT_HOLD_METAL_WATER_STANDING",
    [ACT_METAL_WATER_WALKING] = "ACT_METAL_WATER_WALKING",
    [ACT_HOLD_METAL_WATER_WALKING] = "ACT_HOLD_METAL_WATER_WALKING",
    [ACT_METAL_WATER_FALLING] = "ACT_METAL_WATER_FALLING",
    [ACT_HOLD_METAL_WATER_FALLING] = "ACT_HOLD_METAL_WATER_FALLING",
    [ACT_METAL_WATER_FALL_LAND] = "ACT_METAL_WATER_FALL_LAND",
    [ACT_HOLD_METAL_WATER_FALL_LAND] = "ACT_HOLD_METAL_WATER_FALL_LAND",
    [ACT_METAL_WATER_JUMP] = "ACT_METAL_WATER_JUMP",
    [ACT_HOLD_METAL_WATER_JUMP] = "ACT_HOLD_METAL_WATER_JUMP",
    [ACT_METAL_WATER_JUMP_LAND] = "ACT_METAL_WATER_JUMP_LAND",
    [ACT_HOLD_METAL_WATER_JUMP_LAND] = "ACT_HOLD_METAL_WATER_JUMP_LAND",
    [ACT_DISAPPEARED] = "ACT_DISAPPEARED",
    [ACT_INTRO_CUTSCENE] = "ACT_INTRO_CUTSCENE",
    [ACT_STAR_DANCE_EXIT] = "ACT_STAR_DANCE_EXIT",
    [ACT_STAR_DANCE_WATER] = "ACT_STAR_DANCE_WATER",
    [ACT_FALL_AFTER_STAR_GRAB] = "ACT_FALL_AFTER_STAR_GRAB",
    [ACT_READING_AUTOMATIC_DIALOG] = "ACT_READING_AUTOMATIC_DIALOG",
    [ACT_READING_NPC_DIALOG] = "ACT_READING_NPC_DIALOG",
    [ACT_STAR_DANCE_NO_EXIT] = "ACT_STAR_DANCE_NO_EXIT",
    [ACT_READING_SIGN] = "ACT_READING_SIGN",
    [ACT_JUMBO_STAR_CUTSCENE] = "ACT_JUMBO_STAR_CUTSCENE",
    [ACT_WAITING_FOR_DIALOG] = "ACT_WAITING_FOR_DIALOG",
    [ACT_DEBUG_FREE_MOVE] = "ACT_DEBUG_FREE_MOVE",
    [ACT_STANDING_DEATH] = "ACT_STANDING_DEATH",
    [ACT_QUICKSAND_DEATH] = "ACT_QUICKSAND_DEATH",
    [ACT_ELECTROCUTION] = "ACT_ELECTROCUTION",
    [ACT_SUFFOCATION] = "ACT_SUFFOCATION",
    [ACT_DEATH_ON_STOMACH] = "ACT_DEATH_ON_STOMACH",
    [ACT_DEATH_ON_BACK] = "ACT_DEATH_ON_BACK",
    [ACT_EATEN_BY_BUBBA] = "ACT_EATEN_BY_BUBBA",
    [ACT_END_PEACH_CUTSCENE] = "ACT_END_PEACH_CUTSCENE",
    [ACT_CREDITS_CUTSCENE] = "ACT_CREDITS_CUTSCENE",
    [ACT_END_WAVING_CUTSCENE] = "ACT_END_WAVING_CUTSCENE",
    [ACT_PULLING_DOOR] = "ACT_PULLING_DOOR",
    [ACT_PUSHING_DOOR] = "ACT_PUSHING_DOOR",
    [ACT_WARP_DOOR_SPAWN] = "ACT_WARP_DOOR_SPAWN",
    [ACT_EMERGE_FROM_PIPE] = "ACT_EMERGE_FROM_PIPE",
    [ACT_SPAWN_SPIN_AIRBORNE] = "ACT_SPAWN_SPIN_AIRBORNE",
    [ACT_SPAWN_SPIN_LANDING] = "ACT_SPAWN_SPIN_LANDING",
    [ACT_EXIT_AIRBORNE] = "ACT_EXIT_AIRBORNE",
    [ACT_EXIT_LAND_SAVE_DIALOG] = "ACT_EXIT_LAND_SAVE_DIALOG",
    [ACT_DEATH_EXIT] = "ACT_DEATH_EXIT",
    [ACT_UNUSED_DEATH_EXIT] = "ACT_UNUSED_DEATH_EXIT",
    [ACT_FALLING_DEATH_EXIT] = "ACT_FALLING_DEATH_EXIT",
    [ACT_SPECIAL_EXIT_AIRBORNE] = "ACT_SPECIAL_EXIT_AIRBORNE",
    [ACT_SPECIAL_DEATH_EXIT] = "ACT_SPECIAL_DEATH_EXIT",
    [ACT_FALLING_EXIT_AIRBORNE] = "ACT_FALLING_EXIT_AIRBORNE",
    [ACT_UNLOCKING_KEY_DOOR] = "ACT_UNLOCKING_KEY_DOOR",
    [ACT_UNLOCKING_STAR_DOOR] = "ACT_UNLOCKING_STAR_DOOR",
    [ACT_ENTERING_STAR_DOOR] = "ACT_ENTERING_STAR_DOOR",
    [ACT_SPAWN_NO_SPIN_AIRBORNE] = "ACT_SPAWN_NO_SPIN_AIRBORNE",
    [ACT_SPAWN_NO_SPIN_LANDING] = "ACT_SPAWN_NO_SPIN_LANDING",
    [ACT_BBH_ENTER_JUMP] = "ACT_BBH_ENTER_JUMP",
    [ACT_BBH_ENTER_SPIN] = "ACT_BBH_ENTER_SPIN",
    [ACT_TELEPORT_FADE_OUT] = "ACT_TELEPORT_FADE_OUT",
    [ACT_TELEPORT_FADE_IN] = "ACT_TELEPORT_FADE_IN",
    [ACT_SHOCKED] = "ACT_SHOCKED",
    [ACT_SQUISHED] = "ACT_SQUISHED",
    [ACT_HEAD_STUCK_IN_GROUND] = "ACT_HEAD_STUCK_IN_GROUND",
    [ACT_BUTT_STUCK_IN_GROUND] = "ACT_BUTT_STUCK_IN_GROUND",
    [ACT_FEET_STUCK_IN_GROUND] = "ACT_FEET_STUCK_IN_GROUND",
    [ACT_PUTTING_ON_CAP] = "ACT_PUTTING_ON_CAP",
    [ACT_HOLDING_POLE] = "ACT_HOLDING_POLE",
    [ACT_GRAB_POLE_SLOW] = "ACT_GRAB_POLE_SLOW",
    [ACT_GRAB_POLE_FAST] = "ACT_GRAB_POLE_FAST",
    [ACT_CLIMBING_POLE] = "ACT_CLIMBING_POLE",
    [ACT_TOP_OF_POLE_TRANSITION] = "ACT_TOP_OF_POLE_TRANSITION",
    [ACT_TOP_OF_POLE] = "ACT_TOP_OF_POLE",
    [ACT_START_HANGING] = "ACT_START_HANGING",
    [ACT_HANGING] = "ACT_HANGING",
    [ACT_HANG_MOVING] = "ACT_HANG_MOVING",
    [ACT_LEDGE_GRAB] = "ACT_LEDGE_GRAB",
    [ACT_LEDGE_CLIMB_SLOW_1] = "ACT_LEDGE_CLIMB_SLOW_1",
    [ACT_LEDGE_CLIMB_SLOW_2] = "ACT_LEDGE_CLIMB_SLOW_2",
    [ACT_LEDGE_CLIMB_DOWN] = "ACT_LEDGE_CLIMB_DOWN",
    [ACT_LEDGE_CLIMB_FAST] = "ACT_LEDGE_CLIMB_FAST",
    [ACT_GRABBED] = "ACT_GRABBED",
    [ACT_IN_CANNON] = "ACT_IN_CANNON",
    [ACT_TORNADO_TWIRLING] = "ACT_TORNADO_TWIRLING",
    [ACT_BUBBLED] = "ACT_BUBBLED",
    [ACT_PUNCHING] = "ACT_PUNCHING",
    [ACT_PICKING_UP] = "ACT_PICKING_UP",
    [ACT_DIVE_PICKING_UP] = "ACT_DIVE_PICKING_UP",
    [ACT_STOMACH_SLIDE_STOP] = "ACT_STOMACH_SLIDE_STOP",
    [ACT_PLACING_DOWN] = "ACT_PLACING_DOWN",
    [ACT_THROWING] = "ACT_THROWING",
    [ACT_HEAVY_THROW] = "ACT_HEAVY_THROW",
    [ACT_PICKING_UP_BOWSER] = "ACT_PICKING_UP_BOWSER",
    [ACT_HOLDING_BOWSER] = "ACT_HOLDING_BOWSER",
    [ACT_RELEASING_BOWSER] = "ACT_RELEASING_BOWSER",
    [ACT_KTOOLS_DEBUG_MOVE] = "ACT_KTOOLS_DEBUG_MOVE",
    [ACT_KTOOLS_LOCKED] = "ACT_KTOOLS_LOCKED"
}

gKingDevTools = {}
for i = 0, (MAX_PLAYERS - 1) do
    gKingDevTools[i] = {
        ["showHud"] = true,
        ["showStats"] = 0,
        ["levelSelect"] = {
            ["enabled"] = 0,
            ["level"] = 0,
            ["star"] = 1,
            ["test"] = 0
        },
        ["capSelect"] = {
            ["enabled"] = 0,
            ["cap"] = 0,
        }
    }
end

hook_chat_command("dev_hide", "Toggles the devtool button prompts", function(msg)
    gKingDevTools[0].showHud = not gKingDevTools[0].showHud
    return true
end)

function _G.ktools_act_name(action, name)
    table.insert(actNames, action)
    actNames[action] = name
end

function wrap_value(value, minimum, maximum)
    if minimum ~= nil and value < minimum then
        value = maximum
    end
    if maximum ~= nil and value > maximum then
        value = minimum
    end
    return value
end

function select_value(m, value, INC_BUTTON, DEC_BUTTON, minimum, maximum)
    if (m.controller.buttonPressed & INC_BUTTON) ~= 0 then
        value = value + 1
        play_sound(SOUND_MENU_CHANGE_SELECT, m.marioObj.header.gfx.cameraToObject)
    end
    if (m.controller.buttonPressed & DEC_BUTTON) ~= 0 then
        value = value - 1
        play_sound(SOUND_MENU_CHANGE_SELECT, m.marioObj.header.gfx.cameraToObject)
    end

    value = wrap_value(value, minimum, maximum)
    return value
end

function mario_update(m)
    local ktools = gKingDevTools[m.playerIndex]

    if m.playerIndex == 0 then
        if ktools.levelSelect.enabled == 1
        or ktools.capSelect.enabled == 1 then
            set_mario_action(m, ACT_KTOOLS_LOCKED, 0)
        else
            if m.action == ACT_KTOOLS_LOCKED then
                set_mario_action(m, ACT_FREEFALL, 0)
            end
        end

        if ktools.levelSelect.enabled ~= 0 then
            ktools.levelSelect.level = select_value(m, ktools.levelSelect.level, U_JPAD, D_JPAD, 1, LEVEL_COUNT)
            ktools.levelSelect.star = select_value(m, ktools.levelSelect.star, R_JPAD, L_JPAD, 1, 6)

            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                local warp = false

                if ktools.levelSelect.level ~= LEVEL_ENDING then
                    warp = warp_to_level(ktools.levelSelect.level, 1, ktools.levelSelect.star)
                    if warp == true then
                        ktools.levelSelect.enabled = 0
                    else
                        play_sound(SOUND_MENU_CAMERA_BUZZ, m.marioObj.header.gfx.cameraToObject)
                    end
                else
                    lvl_set_current_level(0, LEVEL_ENDING)
                    fade_into_special_warp(SPECIAL_WARP_CAKE, 0x000000)
                    ktools.levelSelect.enabled = 0
                end
            end

            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                ktools.levelSelect.enabled = 0
            end
        else
            ktools.levelSelect.level = gNetworkPlayers[0].currLevelNum
            ktools.levelSelect.star = 1
        end

        if ktools.capSelect.enabled ~= 0 then
            ktools.capSelect.cap = select_value(m, ktools.capSelect.cap, R_JPAD, L_JPAD, 0, 2)

            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                if ktools.capSelect.cap == 0 then
                    if (m.flags & MARIO_WING_CAP) == 0 then
                        m.flags = m.flags | MARIO_WING_CAP
                    else
                        m.flags = m.flags & ~MARIO_WING_CAP
                    end
                end

                if ktools.capSelect.cap == 1 then
                    if (m.flags & MARIO_VANISH_CAP) == 0 then
                        m.flags = m.flags | MARIO_VANISH_CAP
                    else
                        m.flags = m.flags & ~MARIO_VANISH_CAP
                    end
                end

                if ktools.capSelect.cap == 2 then
                    if (m.flags & MARIO_METAL_CAP) == 0 then
                        m.flags = m.flags | MARIO_METAL_CAP
                    else
                        m.flags = m.flags & ~MARIO_METAL_CAP
                    end
                end

                local capTime = m.capTimer
                local capMusic = nil

                if (m.flags & MARIO_WING_CAP) ~= 0 then
                    capTime = max(capTime, gLevelValues.wingCapDuration)
                    capMusic = gLevelValues.wingCapSequence
                end
                if (m.flags & MARIO_VANISH_CAP) ~= 0 then
                    capTime = max(capTime, gLevelValues.vanishCapDuration)
                    capMusic = gLevelValues.vanishCapSequence
                end
                if (m.flags & MARIO_METAL_CAP) ~= 0 then
                    capTime = max(capTime, gLevelValues.metalCapDuration)
                    capMusic = gLevelValues.metalCapSequence
                end

                m.capTimer = capTime

                if capMusic ~= nil then
                    play_cap_music(capMusic)
                else
                    stop_cap_music()
                end

                ktools.capSelect.enabled = 0
            end

            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                ktools.capSelect.enabled = 0
            end
        end

        if m.action ~= ACT_KTOOLS_LOCKED then
            if (m.controller.buttonPressed & U_JPAD) ~= 0 then
                if m.action == ACT_KTOOLS_DEBUG_MOVE then
                    set_mario_action(m, ACT_FREEFALL, 0)
                else
                    set_mario_action(m, ACT_KTOOLS_DEBUG_MOVE, 0)
                end
            end

            if (m.controller.buttonPressed & D_JPAD) ~= 0 then
                if ktools.showStats == 0 then
                    ktools.showStats = 1
                else
                    ktools.showStats = 0
                end
            end

            if (m.controller.buttonPressed & L_JPAD) ~= 0 then
                ktools.levelSelect.enabled = 1
            end

            if (m.controller.buttonPressed & R_JPAD) ~= 0 then
                ktools.capSelect.enabled = 1
            end
        end
    end
end

function door_stuff(m)
    local dist = 150
    local doorwarp = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoorWarp)
    local door = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvDoor)
    local stardoor = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvStarDoor)

    if doorwarp ~= nil and dist_between_objects(m.marioObj, doorwarp) < dist then
        local actionArg = should_push_or_pull_door(m, doorwarp) + 4

        if doorwarp.oAction == 0 then
            if (actionArg & 1) ~= 0 then
                doorAction = ACT_PULLING_DOOR
            else
                doorAction = ACT_PUSHING_DOOR
            end

            m.interactObj = doorwarp
            m.usedObj = doorwarp
            return set_mario_action(m, doorAction, actionArg)
        end
    elseif door ~= nil and dist_between_objects(m.marioObj, door) < dist then
        if door.oAction == 0 then
            if (should_push_or_pull_door(m, door) & 1) ~= 0 then
                door.oInteractStatus = 0x00010000
            else
                door.oInteractStatus = 0x00020000
            end
        end
    elseif stardoor ~= nil and dist_between_objects(m.marioObj, stardoor) < dist then
        if stardoor.oAction == 0 then
            stardoor.oInteractStatus = 0x00010000
        end
    end
end

function act_ktools_debug_move(m)
    local speed = 48

    if (m.controller.buttonDown & B_BUTTON) ~= 0 then
        speed = 96
    end

    set_mario_animation(m, MARIO_ANIM_A_POSE)

    local upDown = 0
    if (m.controller.buttonDown & A_BUTTON) ~= 0 then
        upDown = upDown + 1
    end
    if (m.controller.buttonDown & Z_TRIG) ~= 0 then
        upDown = upDown - 1
    end

    m.vel.y = upDown * speed/2
    m.forwardVel = m.intendedMag/32 * speed

    if m.pos.y == m.floorHeight and m.vel.y <= 0 then
        perform_ground_step(m)
    else
        perform_air_step(m, 0)
    end

    m.faceAngle.y = m.intendedYaw
    m.vel.x = m.forwardVel * sins(m.faceAngle.y)
    m.vel.z = m.forwardVel * coss(m.faceAngle.y)

    door_stuff(m)
end

function act_ktools_locked(m)
    set_mario_animation(m, MARIO_ANIM_A_POSE)

    m.forwardVel = 0
    perform_air_step(m, 0)

    m.vel.x = 0
    m.vel.y = 0
    m.vel.z = 0
end

local levelTable = {
    --[LEVEL_UNKNOWN_1] =        nil,
    --[LEVEL_UNKNOWN_2] =        nil,
    --[LEVEL_UNKNOWN_3] =        nil,
    [LEVEL_BBH] =              {["course"] = COURSE_BBH,      ["name"] = "TERESA OBAKE"},
    [LEVEL_CCM] =              {["course"] = COURSE_CCM,      ["name"] = "YYAMA1 & YSLD1"},
    [LEVEL_CASTLE] =           {["course"] = COURSE_NONE,     ["name"] = "SELECT ROOM"},
    [LEVEL_HMC] =              {["course"] = COURSE_HMC,      ["name"] = "HORROR DUNGEON"},
    [LEVEL_SSL] =              {["course"] = COURSE_SSL,      ["name"] = "SABAKU & PYRMD"},
    [LEVEL_BOB] =              {["course"] = COURSE_BOB,      ["name"] = "BATTLE FIELD"},
    [LEVEL_SL] =               {["course"] = COURSE_SL,       ["name"] = "YUKIYAMA2"},
    [LEVEL_WDW] =              {["course"] = COURSE_WDW,      ["name"] = "POOL KAI"},
    [LEVEL_JRB] =              {["course"] = COURSE_JRB,      ["name"] = "WTDG & TINBOTU"},
    [LEVEL_THI] =              {["course"] = COURSE_THI,      ["name"] = "BIG WORLD"},
    [LEVEL_TTC] =              {["course"] = COURSE_TTC,      ["name"] = "CLOCK TOWER"},
    [LEVEL_RR] =               {["course"] = COURSE_RR,       ["name"] = "RAINBOW CRUISE"},
    [LEVEL_CASTLE_GROUNDS] =   {["course"] = COURSE_NONE,     ["name"] = "MAIN MAP"},
    [LEVEL_BITDW] =            {["course"] = COURSE_BITDW,    ["name"] = "EXT1 YOKO SCRL"},
    [LEVEL_VCUTM] =            {["course"] = COURSE_VCUTM,    ["name"] = "EXT7 HORI MINI"},
    [LEVEL_BITFS] =            {["course"] = COURSE_BITFS,    ["name"] = "EXT2 TIKA LAVA"},
    [LEVEL_SA] =               {["course"] = COURSE_SA,       ["name"] = "EXT9 SUISOU"},
    [LEVEL_BITS] =             {["course"] = COURSE_BITS,     ["name"] = "EXT3 HEAVEN"},
    [LEVEL_LLL] =              {["course"] = COURSE_LLL,      ["name"] = "FIREB1 & INVLC"},
    [LEVEL_DDD] =              {["course"] = COURSE_DDD,      ["name"] = "WATER LAND"},
    [LEVEL_WF] =               {["course"] = COURSE_WF,       ["name"] = "MOUNTAIN"},
    [LEVEL_ENDING] =           {["course"] = COURSE_CAKE_END, ["name"] = "ENDING"},
    [LEVEL_CASTLE_COURTYARD] = {["course"] = COURSE_NONE,     ["name"] = "URANIWA"},
    [LEVEL_PSS] =              {["course"] = COURSE_PSS,      ["name"] = "EXT4 MINI SLID"},
    [LEVEL_COTMC] =            {["course"] = COURSE_COTMC,    ["name"] = "IN THE FALL"},
    [LEVEL_TOTWC] =            {["course"] = COURSE_TOTWC,    ["name"] = "EXT6 MARIO FLY"},
    [LEVEL_BOWSER_1] =         {["course"] = COURSE_BITDW,    ["name"] = "KUPPA1"},
    [LEVEL_WMOTR] =            {["course"] = COURSE_WMOTR,    ["name"] = "EXT8 BLUE SKY"},
    --[LEVEL_UNKNOWN_32] =       nil,
    [LEVEL_BOWSER_2] =         {["course"] = COURSE_BITFS,    ["name"] = "KUPPA2"},
    [LEVEL_BOWSER_3] =         {["course"] = COURSE_BITS,     ["name"] = "KUPPA3"},
    --[LEVEL_UNKNOWN_35] =       nil,
    [LEVEL_TTM] =              {["course"] = COURSE_TTM,      ["name"] = "DONKEY & SLID2"},
    --[LEVEL_UNKNOWN_37] =       nil,
    --[LEVEL_UNKNOWN_38] =       nil
}

function djui_hud_print_text_shadowed(message, x, y, scale)
    local color = djui_hud_get_color()

    djui_hud_set_color(0, 0, 0, color.a)
    djui_hud_print_text(message, x + 2*scale, y + 2*scale, scale)

    djui_hud_set_color(color.r, color.b, color.g, color.a)
    djui_hud_print_text(message, x, y, scale)
end

function draw_debug_hud()
    local ktools = gKingDevTools[0]

    if hud_is_hidden() or (gMarioStates[0].marioObj.activeFlags & ACTIVE_FLAG_ACTIVE) == 0 then
        return
    end

    local x = 22
    local y = djui_hud_get_screen_height() - 31
    local y2 = y - 20
    local y3 = y2 - 20
    local y4 = y3 - 20

    local dpad = {
        ["up"] = get_texture_info("kdev.dpad_up"),
        ["down"] = get_texture_info("kdev.dpad_down"),
        ["left"] = get_texture_info("kdev.dpad_left"),
        ["right"] = get_texture_info("kdev.dpad_right")
    }

    if ktools.levelSelect.enabled == 0
    and ktools.capSelect.enabled == 0 then
        if ktools.showHud then
            -- debug move
            djui_hud_render_texture(dpad.up, x - 8, y4 - 8, 1, 1)
            djui_hud_render_texture(get_texture_info("kdev.apose"), x*2 - 8, y4 - 8, 1, 1)

            -- down
            djui_hud_render_texture(dpad.down, x - 8, y3 - 8, 1, 1)
            djui_hud_render_texture(get_texture_info("kdev.stats"), x*2, y3, 1, 1)

            -- left
            djui_hud_render_texture(dpad.left, x - 8, y2 - 8, 1, 1)
            djui_hud_render_texture(get_texture_info("kdev.select"), x*2 - 8, y2, 1, 1)

            -- king save
            djui_hud_render_texture(dpad.right, x - 8, y - 8, 1, 1)
            djui_hud_render_texture(get_texture_info("kdev.cap"), x*2, y, 1, 1)
        end

        if ktools.showStats == 1 then
            local m = gMarioStates[0]
            local newY = 24

            local SPD = string.format("SPD %.0f", m.forwardVel):gsub("-", "M")

            djui_hud_set_font(FONT_CUSTOM_HUD)
            djui_hud_print_text(SPD, x, newY, 1)

            djui_hud_set_font(FONT_CUSTOM_HUD)
            djui_hud_print_text("VEL", x, newY*2, 0.75)

            local VELX = string.format("X: %.0f", m.vel.x)
            local VELY = string.format("Y: %.0f", m.vel.y)
            local VELZ = string.format("Z: %.0f", m.vel.z)

            djui_hud_set_font(FONT_NORMAL)
            djui_hud_print_text_shadowed(VELX, x, newY*2.875, 0.375)
            djui_hud_print_text_shadowed(VELY, x, newY*3.375, 0.375)
            djui_hud_print_text_shadowed(VELZ, x, newY*3.875, 0.375)

            djui_hud_set_font(FONT_CUSTOM_HUD)
            djui_hud_print_text("POS", x*3, newY*2, 0.75)

            local POSX = string.format("X: %.0f", m.pos.x)
            local POSY = string.format("Y: %.0f", m.pos.y)
            local POSZ = string.format("Z: %.0f", m.pos.z)

            djui_hud_set_font(FONT_NORMAL)
            djui_hud_print_text_shadowed(POSX, x*3, newY*2.875, 0.375)
            djui_hud_print_text_shadowed(POSY, x*3, newY*3.375, 0.375)
            djui_hud_print_text_shadowed(POSZ, x*3, newY*3.875, 0.375)

            djui_hud_set_font(FONT_CUSTOM_HUD)
            djui_hud_print_text("ANG", x*5, newY*2, 0.75)

            local ANGX = string.format("X: %.0f", m.faceAngle.x)
            local ANGY = string.format("Y: %.0f", m.faceAngle.y)
            local ANGZ = string.format("Z: %.0f", m.faceAngle.z)

            djui_hud_set_font(FONT_NORMAL)
            djui_hud_print_text_shadowed(ANGX, x*5, newY*2.875, 0.375)
            djui_hud_print_text_shadowed(ANGY, x*5, newY*3.375, 0.375)
            djui_hud_print_text_shadowed(ANGZ, x*5, newY*3.875, 0.375)

            local ACT = string.upper(string.format("ACT 0*%x", (m.action & ACT_ID_MASK)))

            djui_hud_set_font(FONT_CUSTOM_HUD)
            djui_hud_print_text(string.upper(ACT), x, newY*4.125, 1)

            if actNames[m.action] then
                local ACT2 = actNames[m.action]

                djui_hud_set_font(FONT_NORMAL)
                djui_hud_print_text_shadowed(ACT2, x + 1, newY*5.25, 0.5)
                djui_hud_set_font(FONT_CUSTOM_HUD)
            end
        end
    else
        if ktools.showHud then
            -- confirm
            djui_hud_render_texture(get_texture_info("kdev.abutton"), x, y2, 1, 1)
            djui_hud_render_texture(get_texture_info("kdev.tick"), x*2, y2, 1, 1)

            -- exit
            djui_hud_render_texture(get_texture_info("kdev.bbutton"), x, y, 1, 1)
            djui_hud_render_texture(gTextures.no_camera, x*2, y, 1, 1)
        end

        if ktools.levelSelect.enabled == 1 then
            local baseX = djui_hud_get_screen_width()/2 - 320/2
            local levelNum = tostring(ktools.levelSelect.level)
            djui_hud_print_text(levelNum, baseX + 224 - djui_hud_measure_text(levelNum), djui_hud_get_screen_height() - 81, 1)

            djui_hud_set_color(0, 0, 255, 127)
            djui_hud_render_texture(gTextures.star, baseX + 80, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 100, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 120, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 140, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 160, y3, 1, 1)
            djui_hud_render_texture(gTextures.star, baseX + 180, y3, 1, 1)
            djui_hud_set_color(255, 255, 255, 255)

            djui_hud_render_texture(gTextures.star, baseX + 60 + 20*ktools.levelSelect.star - 1.6, y3 - 1.6, 1.2, 1.2)

            local name1 = "UNKNOWN"
            local name2 = "UNKNOWN LEVEL"

            if levelTable[ktools.levelSelect.level] ~= nil then
                name1 = levelTable[ktools.levelSelect.level].name
                name2 = string.upper(get_level_name(levelTable[ktools.levelSelect.level].course, ktools.levelSelect.level, 1))
            end

            djui_hud_print_text(name1, baseX + 80, djui_hud_get_screen_height() - 60, 1)
            djui_hud_print_text(name2, baseX + 80, djui_hud_get_screen_height() - 35, 0.5)
        end

        if ktools.capSelect.enabled == 1 then
            local baseX = djui_hud_get_screen_width()/2
            local box = {
                [0] = get_texture_info("kdev.wingbox"),
                [1] = get_texture_info("kdev.vanishbox"),
                [2] = get_texture_info("kdev.metalbox")
            }

            djui_hud_render_texture(box[0], baseX - 28, y, 0.5, 0.5)
            djui_hud_render_texture(box[1], baseX - 8, y, 0.5, 0.5)
            djui_hud_render_texture(box[2], baseX + 12, y, 0.5, 0.5)

            djui_hud_render_texture(box[ktools.capSelect.cap], baseX - 28 + 20*ktools.capSelect.cap - 1.6, y - 1.6, 0.6, 0.6)
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_mario_action(ACT_KTOOLS_DEBUG_MOVE, act_ktools_debug_move)
hook_mario_action(ACT_KTOOLS_LOCKED, act_ktools_locked)

hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_set_font(FONT_CUSTOM_HUD)

    draw_debug_hud()
end)